clear all
close all
clc

datapath = '../output/Period3_Target/';%change data path here
%% 
load(strcat(datapath, 'ests_x.mat'))%this is MCMC output
%% 
rawData = readmatrix("../input/model_input_mcmc_new.xlsx"); %this is the real data

raw_n2 = rawData(:,5);
raw_mandatory = rawData(:,8);
raw_CJR = rawData(:,3);
raw_strata = rawData(:,4);
%% Cut Burn-in
burnin_point = 10000;
for cv = who('*_finish')' %transpose to get a row cell array
  eval(sprintf('%1$s = %1$s(:,[burnin_point+1:size(%1$s,2)]);', cv{1})); %1$s is replaced by var name, output is named meanvarname
end
%% get total number of episodes for each stratum
epsds_s_all = [];
for i=1:8
    epsds_s_all = [epsds_s_all, sum(raw_n2(raw_strata==i))];
end

epsds_s_vol = [];
for i=1:8
    epsds_s_vol = [epsds_s_vol, sum(raw_n2(raw_strata==i & raw_CJR==1 & raw_mandatory==0))];
end
%%
vw8 = epsds_s_all'; %weight lambda and omega using all hospitals
vw6 = epsds_s_vol([1:3,5:7])'; %weigt u using only voluntary hospitals
%%
CalcMeanStd2 = @(var) [mean(var,2),std(var,[],2)];
xx_wMean = @(x,w) sum(x.*w)./sum(w);
xx_wStd = @(x,w) sqrt(sum((x-xx_wMean(x,w)).^2.*w)./sum(w));

%% construct Table 4A except the Constant row
x1_raw = CalcMeanStd2(alpha1_finish);
x2_raw = CalcMeanStd2(alpha2_finish);
x3_raw = CalcMeanStd2(alpha3_finish./beta1_finish);

x1_tmp = x1_raw([12:14,9:11],:);
x2_tmp = x2_raw([12:14,9:11],:);
x3_tmp = x3_raw([10:12,7:9],:);

tb4_panelA_noconstant = [x1_tmp,x2_tmp,x3_tmp];
%% construct the constant row in Table 4A
str1_raw = alpha1_finish(1:8,:);
str2_raw = alpha2_finish(1:8,:);
tmp = alpha3_finish./beta1_finish;
str3_raw = tmp(1:6,:);

str1 = xx_wMean(str1_raw,vw8);
str2 = xx_wMean(str2_raw,vw8);
str3 = xx_wMean(str3_raw,vw6);

tb4_panelA_constant = [CalcMeanStd2(str1),CalcMeanStd2(str2),CalcMeanStd2(str3)];
%% 
table3a_upper = [tb4_panelA_constant;tb4_panelA_noconstant];
writematrix(table3a_upper, '../output/Period3_Target/tb3_tb4_tb5_mcmc_x_period3.xlsx', 'sheet', 'Table 3', 'range', 'B6');
