clear;clc;close all
rng(2021)
% addpath('../lib')

output_path = './output/Period3_Target';
data_path = './input/model_input_mcmc_new.xlsx';
chars_path = './input/hosp_char_mcmc.xlsx';

%% Preliminary
% Load data
T = readtable(data_path);
x = readtable(chars_path);
T = join(T, x, 'Keys', 'provider');
H = size(T, 1);
% Treatement, selection, outcome
lny1 = T.logy1;
y2 = exp(T.logy2);
y3 = exp(T.logy3);
BP2 = T.CJR;
mandatory = T.mandatory & BP2 == 1;
t = exp(T.log_tau);
t(BP2 == 0 | mandatory == 1) = 0;
BP3 = T.selection;
selection = BP3 == 1 & mandatory == 0;
H1 = find(BP2 == 0);
H2 = find(BP2 == 1 & mandatory == 1);
H3 = find(BP2 == 1 & mandatory == 0 & selection == 1);
H4 = find(BP2 == 1 & mandatory == 0 & selection == 0);
H234 = [H2; H3; H4];
H23 = [H2; H3];
H12 = [H1; H2];
H34 = [H3; H4];
% Weights
weights = T.num_epsd;
weights = weights / sum(weights) * H;
w = diag(weights(H34) / sum(weights(H34)) * length(H34));
% Characteristics
types = [T.prov_coth, T.prov_fp, T.prov_govt];
bin = [T.prov_gtmedepsds, T.prov_gtmedbeds, T.prov_cqs_abovemed];
cnt = [log(T.num_epsd_pre_T), log(T.prov_beds), T.cqs];
chars_raw = [types, cnt];
chars = (chars_raw - wmean(chars_raw, repmat(weights, 1, size(chars_raw, 2)))) ./ sqrt(var(chars_raw, weights));
sd_chars = sqrt(var(chars_raw, weights))