
************************************************************************;
* DESCRIPTION:                                                         *;
* This program generates LEJR episode level datasets for each pre year *;
************************************************************************;

*********************;
*LIBRARY AND OPTIONS*;
*********************;

options pagesize=200;
options nocenter;
options mprint mlogic;
options errorabend;
options errorbyabend;
options errorcheck = strict;
options msglevel=i;
options notes stimer fullstimer;
options formdlim="-";
options mergenoby=error;
options filelocks=none;
options syntaxcheck;
options vnferr;
options varinitchk = error;
options varlenchk = nowarn;

libname mc '[DATA DIR]';
libname temp '[TEMP DIR]';
libname output '[OUTPUT DIR]';

%include 'build_episode_data_views_pre.sas';
%let numobs = MAX;

****************;
*LOAD CSV FILES*;
****************;

%macro importcsv(filename);
proc import datafile="[INPUT DIR]/&filename..csv"
	out=temp.&filename. dbms=csv replace; 
	getnames=yes; 
	GUESSINGROWS=MAX;
run;
%mend;
%importcsv(drg_gmlos2015);
%importcsv(ip_readmission_exclusions);
%importcsv(provider_to_msa_xwalk2016);
%importcsv(ptb_excluded_icd9);
%importcsv(ptb_excluded_icd10);
%importcsv(ssacounty_to_msa_xwalk);
%importcsv(treatment_eligible_strata);
%importcsv(hip_fracture_icd9);
%importcsv(hip_fracture_icd10);
%importcsv(bpci_hosps_2014);
%importcsv(bpci_hosps_2015);
%importcsv(bpci_hosps_2016);
data temp.ip_readmission_exclusions (rename = (drg = drg_cd));
	set temp.ip_readmission_exclusions;
	drg = put(drg_cd, 3.);
	drop drg_cd;
run;

********************;
*BUILD EPISODE DATA*;
********************;
%build_episode_data_pre(2014);
%build_episode_data_pre(2013);
%build_episode_data_pre(2012);
%build_episode_data_pre(2011);
%build_episode_data_pre(2010);