version 16
set more off
preliminaries
clear all

global data_dir = "[DATA DIR]"

program main
    make_scatterplot
end

program make_scatterplot

	use "$data_dir/output/all_episode_level_data2016_2018.dta", clear
	
    keep if year(admsn_dt) == 2018
    keep if Treatment == 1 & Final_MSAs == 1 & cjr_sample == 1
    rename *, lower
    rename treatment Treatment
    keep Treatment provider drg_cd hip_fracture_flag admsn_dt 
    
    rename hip_fracture_flag fracture
    destring drg_cd, replace
    
    * Merge with appropriate targets
    merge m:1 provider drg_cd fracture using "${data_dir}/target_hat_py3", ///
	    keepusing(target_hat_py3 target_price_py3) nogen
		
	keep if target_hat_py3 != .
	collapse (mean) target_hat_py3 target_price_py3, by(provider)
	
	twoway (scatter target_price_py3 target_hat_py3) ///
	(lfit target_price_py3 target_price_py3, lcolor(red)), ///
	ylabel(#6,angle(0)) xlabel(#6) ///
	scheme(s1mono) legend(off) xtitle(Observed Period 3 Bundle Price) ytitle(Predicted Period 3 Bundle Price)
	graph export "../output/FigureA1.pdf", replace
	
end
* Execute
main
