version 15
preliminaries
global data_dir = "[DATA DIR]"

global Outcomes = "ach_spend car_spend dme_spend hha_spend hos_spend inst_pac_spend"
global Outcomes = "$Outcomes irf_spend ipf_spend index_spend ltch_spend op_spend other_spend"
global Outcomes = "$Outcomes pac_spend snf_spend tot_spend"
global Outcomes = "$Outcomes dschrg_pac dschrg_inst_pac index_los inst_pac_los er_visit"
global Outcomes = "$Outcomes dschrg_home dschrg_hha dschrg_irf dschrg_snf dschrg_other"

program main
    build_analysis_data, analysis_year(2016_2017) pre_year(2013 2014)
    build_analysis_data, analysis_year(2016_2018) pre_year(2013 2014)
end

program build_analysis_data
    syntax, pre_year(str) analysis_year(str)
    
    foreach year in `pre_year' {
        use if cjr_sample == 1 & Final_MSAs == 1 using ///
	    "../external_links/episode/all_episode_level_data`year'", clear
	    rename *, lower
	    gen dschrg_home = stus_cd == "01"
        gen dschrg_hha = inlist(stus_cd, "06", "86")
        gen dschrg_snf = inlist(stus_cd, "03", "83")
        gen dschrg_irf = inlist(stus_cd, "62", "90")
        gen dschrg_ltch = inlist(stus_cd, "63", "91")
        gen dschrg_other = dschrg_home == 0 & dschrg_pac == 0
	    * tot_pay == ach_pay + car_pay + dme_pay + hha_pay + hos_pay + 
	    * index_pay + ipf_pay + irf_pay + ltch_pay + op_pay + snf_pay
	    * pac_pay == hha_pay + irf_pay + ltch_pay + snf_pay
	    rename los index_los
		gen pac_oop = hha_oop + irf_oop + ltch_oop + snf_oop
		gen inst_pac_oop = irf_oop + ltch_oop + snf_oop
		gen other_pay = tot_pay - index_pay - pac_pay 
		gen other_oop = tot_oop - index_oop - pac_oop
		
	    foreach type in ach car dme hha hos inst_pac irf ipf index ltch op other pac snf tot {
	        gen `type'_spend = `type'_pay + `type'_oop
	    }
	
	    * Keep only providers kept in the provider level file
	    merge m:1 provider using "${data_dir}/output/provider_level_data`analysis_year'", ///
	        keep(3) keepusing(provider) nogen
		
        collapse (mean) $Outcomes, by(msa)
        foreach outcome in $Outcomes {
            rename `outcome' `outcome'_`year'
        }
        save "${data_dir}/temp/mean_outcomes_`year'", replace
    }

    use if cjr_sample == 1 & Final_MSAs == 1 using ///
        "../external_links/episode/all_episode_level_data`analysis_year'", clear
    rename *, lower
    rename treatment Treatment
    rename origtreatment OrigTreatment
    rename origelig OrigElig
    rename final_msas Final_MSAs
    rename control Control
    rename los index_los
    gen dschrg_home = stus_cd == "01"
    gen dschrg_hha = inlist(stus_cd, "06", "86")
    gen dschrg_snf = inlist(stus_cd, "03", "83")
    gen dschrg_irf = inlist(stus_cd, "62", "90")
    gen dschrg_ltch = inlist(stus_cd, "63", "91")
    gen dschrg_other = dschrg_home == 0 & dschrg_pac == 0

  	gen pac_oop = hha_oop + irf_oop + ltch_oop + snf_oop
	gen inst_pac_oop = irf_oop + ltch_oop + snf_oop
	gen other_pay = tot_pay - index_pay - pac_pay 
	gen other_oop = tot_oop - index_oop - pac_oop
		
    foreach type in ach car dme hha hos inst_pac irf ipf index ltch op other pac snf tot {
        gen `type'_spend = `type'_pay + `type'_oop
    }
	
    foreach year in `pre_year' {
        merge m:1 msa using "${data_dir}/temp/mean_outcomes_`year'", ///
            assert(1 2 3) keep(3) nogen
    }

    foreach var in msc* match_id bpci* apr* dec* july* june* sep* oct* jan* ///
        episode_quarter* mar* provider_num {
        capture drop `var'
    }
    
    * Keep only providers kept in the provider level file
    merge m:1 provider using "${data_dir}/output/provider_level_data`analysis_year'", ///
        keep(3) keepusing(provider) nogen

    order _all, alpha

    save_data "${data_dir}/output/episode_level_data`analysis_year'", ///
        log("../output/data_file_manifest.log") key(episode_id) replace
end

* Execute
main
