version 15
preliminaries

global data_dir = "[DATA DIR]"
global ext= "[EXT DIR]"

global Outcomes = "ach_spend car_spend dme_spend hha_spend hos_spend inst_pac_spend"
global Outcomes = "$Outcomes irf_spend ipf_spend index_spend ltch_spend op_spend other_spend"
global Outcomes = "$Outcomes pac_spend snf_spend tot_spend"
global Outcomes = "$Outcomes dschrg_pac dschrg_inst_pac index_los inst_pac_los er_visit"
global Outcomes = "$Outcomes dschrg_home dschrg_hha dschrg_irf dschrg_snf dschrg_other"

program main
    load_data
	build_data_2016_2018
end

program load_data
    
    foreach year in 2013 2014 2016_2018 {
        use if cjr_sample == 1 & Final_MSAs == 1 using ///
	        "$ext/Episode Level Data/output/all_episode_level_data`year'", clear
	    rename *, lower
	    gen dschrg_home = stus_cd == "01"
        gen dschrg_hha = inlist(stus_cd, "06", "86")
        gen dschrg_snf = inlist(stus_cd, "03", "83")
        gen dschrg_irf = inlist(stus_cd, "62", "90")
        gen dschrg_ltch = inlist(stus_cd, "63", "91")
        gen dschrg_other = dschrg_home == 0 & dschrg_pac == 0
	
		gen pac_oop = hha_oop + irf_oop + ltch_oop + snf_oop
		gen inst_pac_oop = irf_oop + ltch_oop + snf_oop
		gen other_pay = tot_pay - index_pay - pac_pay 
		gen other_oop = tot_oop - index_oop - pac_oop
		
	    foreach type in ach car dme hha hos inst_pac irf ipf index ltch op other pac snf tot {
	        gen `type'_spend = `type'_pay + `type'_oop
	    }
		
		gen num_epsd = 1
	    rename los index_los
        rename treatment Treatment
        rename origtreatment OrigTreatment
        rename origelig OrigElig
		rename control Control
        save "${data_dir}/temp/episodes_`year'", replace
	}
	
	foreach year in 2013 2014 {
	    use "${data_dir}/temp/episodes_`year'", clear
        collapse (mean) $Outcomes, by(provider)
        foreach outcome in $Outcomes {
            rename `outcome' `outcome'_`year'
        }
        save "${data_dir}/temp/provider_loaded_`year'", replace
    }
	
	use "${data_dir}/temp/episodes_2013", clear
    append using "${data_dir}/temp/episodes_2014"

    egen num_bene = tag(bene_id provider)

    collapse (sum) num_epsd num_bene (mean) $Outcomes, by(provider)
    foreach var in num_epsd $Outcomes {
        rename `var' `var'_pre
    }
    save "${data_dir}/temp/provider_loaded_pre", replace

end

program build_data_2016_2018

    use "${data_dir}/temp/episodes_2016_2018", clear
	egen num_bene = tag(bene_id provider)
    
    collapse (sum) num_epsd num_bene (mean) $Outcomes, by(provider Treatment Control msa strata)	

	* Mandatory of Voluntary
	merge m:1 msa using "$ext/CJR Parameters/output/final_mandatory_msas.dta", ///
        assert(3) keep(3) keepusing(mandatory) nogen
			
	* Whether selected into treatment
    merge m:1 provider using "$ext/CJR Parameters/output/cjr_treatment_hospitals_py3.dta", ///
        assert(1 2 3) keep(1 3) // _merge = 3 hosp opted into treatment in Year 3
	                        // _merge = 1 hosp opted out of treatment or control
	
    * Treatment hosps opted into treatment in PY3
    gen Select_In = (_merge == 3 & Treatment == 1)
    * Treatment hosps did not opt into treatment in PY3
    gen Select_Out = (_merge == 1 & Treatment == 1)
    
    drop _merge
	
	* Merge with regions (gen indicator for south)
    merge 1:1 provider using "$ext/Provider to Region Crosswalk/output/provider_to_region_xwalk2016", ///
        assert(1 2 3) keep(1 3) keepusing(region_cd region_name) nogen
		
	foreach var in num_epsd num_bene $Outcomes {
        rename `var' `var'_post
    }

    foreach year in 2013 2014 pre {		
	    di "Number of providers in data"
	    unique provider
        merge 1:1 provider using "${data_dir}/temp/provider_loaded_`year'"
		keep if _merge == 3
		drop _merge
    }
	
    order _all, alpha

    save_data "${data_dir}/output/provider_level_data2016_2018", ///
        log("../output/data_file_manifest.log") key(provider) replace
		
		
	use "${data_dir}/temp/episodes_2016_2018", clear
	keep if year(admsn_dt) == 2018
	keep provider
	duplicates drop
	save "${data_dir}/temp/providers_2018", replace
end

* Execute
main
